default:
  image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

stages:
  - plan
  - apply_development
  - apply_production

# -- .Template Jobs --------------------------------------------------------------------------------

.env_vars: { variables: { ENV: $CI_ENVIRONMENT_NAME } }

.plan:
  stage: plan
  when: always
  allow_failure: false
  artifacts:
    paths:
      - envs/${ENV}/.terraform
      - envs/${ENV}/tf_plan
    expire_in: 30 minutes
  script: chmod +x ./scripts/terraform_plan.sh && ./scripts/terraform_plan.sh

.apply:
  when: manual
  allow_failure: false
  script: chmod +x ./scripts/terraform_apply.sh && ./scripts/terraform_apply.sh

# -- Plan Jobs -------------------------------------------------------------------------------------

1_dev_plan:
  environment: { name: dev }
  extends: [ .env_vars, .plan ]

2_prd_plan:
  environment: { name: prd }
  extends: [ .env_vars, .plan ]

# -- Apply Jobs ------------------------------------------------------------------------------------

dev_apply:
  environment: { name: dev }
  extends: [ .env_vars, .apply ]
  stage: apply_development
  needs: [ 1_dev_plan ]

prd_apply:
  environment: { name: prd }
  extends: [ .env_vars, .apply ]
  stage: apply_production
  needs: [ 2_prd_plan ]
  only: [ prod ]
